﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Controls;
using System.IO;


namespace WpfApplication92
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
      //  ObservableCollection<Person> people = new ObservableCollection<Person>();

        BindingList<Person> people = new BindingList<Person>();

        string save = string.Empty;
    
        FieldSortDescription [] sortfields = new FieldSortDescription[5];
        int sortcount = 0;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Person p1 = new Person() { Name = "joe", Age = 34, Occupation = "programmer", Salary = 43500.00 };
            Person p2 = new Person() { Name = "Bob", Age = 44, Occupation = "fireman", Salary = 53500.00 };
            Person p3 = new Person() { Name = "Tim", Age = 24, Occupation = "policeman", Salary = 33500.00 };
            Person p4 = new Person() { Name = "Lou", Age = 54, Occupation = "accountant", Salary = 23500.00 };
            Person p5 = new Person() { Name = "Mat", Age = 64, Occupation = "customer service", Salary = 73500.00 };
            Person p6 = new Person() { Name = "Jef", Age = 14, Occupation = "mechanic", Salary = 83500.00 };
            Person p7 = new Person() { Name = "Lee", Age = 74, Occupation = "teacher", Salary = 93500.00 };

            Person p8 = new Person() { Name = "robert", Age = 74, Occupation = "teacher", Salary = 3500.00 };
            Person p9 = new Person() { Name = "tracy", Age = 54, Occupation = "teacher", Salary = 53500.00 };

            Person p10 = new Person() { Name = "reba", Age = 29, Occupation = "teacher", Salary = 6500.00 };

            Person p11 = new Person() { Name = "trish", Age = 23, Occupation = "teacher", Salary = 2500.00 };





            people.Add(p1);
            people.Add(p2);
            people.Add(p3);
            people.Add(p4);
            people.Add(p5);
            people.Add(p6);
            people.Add(p7);

            people.Add(p8);
            people.Add(p9);
            people.Add(p10);
            people.Add(p11);


            xgrid1.DataSource = people;
            xgrid1.Grouping += new EventHandler<Infragistics.Windows.DataPresenter.Events.GroupingEventArgs>(xgrid1_Grouping);
            xgrid1.Grouped += new EventHandler<Infragistics.Windows.DataPresenter.Events.GroupedEventArgs>(xgrid1_Grouped);
            xgrid1.ExecutingCommand += new EventHandler<Infragistics.Windows.Controls.Events.ExecutingCommandEventArgs>(xgrid1_ExecutingCommand);
            xgrid1.FieldLayoutSettings.AddNewRecordLocation = AddNewRecordLocation.OnTop;
            xgrid1.FieldLayoutSettings.AllowAddNew = true;
            xgrid1.RecordAdded += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordAddedEventArgs>(xgrid1_RecordAdded);
            xgrid1.PreviewKeyDown += new KeyEventHandler(xgrid1_PreviewKeyDown);

            //RecordFilter deptRecordFilter = new RecordFilter { FieldName = "Occupation" };
            //ComparisonCondition salesDeptCondition = new ComparisonCondition(ComparisonOperator.Contains, "policeman");

            //deptRecordFilter.Conditions.Add(salesDeptCondition);

            //this.xgrid1.FieldLayouts[0].RecordFilters.Add(deptRecordFilter);

               
           
             

        }

        void xgrid1_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            //throw new NotImplementedException();
            if (e.Key == Key.Enter)
            {
                if (xgrid1.ActiveCell.Record.IsAddRecord)
                {
                   // MessageBox.Show("hello");
               //     xgrid1.ExecuteCommand(DataPresenterCommands.CellFirstDisplayed);
                    xgrid1.ExecuteCommand(DataPresenterCommands.CellFirstOverall);
                    xgrid1.ExecuteCommand(DataPresenterCommands.CellAbove);
                    xgrid1.ExecuteCommand(DataPresenterCommands.CellBelow);
                 
                }
            }
        }

        void xgrid1_RecordAdded(object sender, Infragistics.Windows.DataPresenter.Events.RecordAddedEventArgs e)
        {
            //throw new NotImplementedException();
         //   
        }


        void xgrid1_ExecutingCommand(object sender, Infragistics.Windows.Controls.Events.ExecutingCommandEventArgs e)
        {
          //  throw new NotImplementedException();
            //MessageBox.Show(e.Command.Name);
            //if (e.Command.Name == "RecordRight")
            //{
            //    e.Cancel = true;
            //    xgrid1.ExecuteCommand(DataPresenterCommands.CellRight);
            //}
            //else if (e.Command.Name == "RecordLeft")
            //{
            //    e.Cancel = true;
            //    xgrid1.ExecuteCommand(DataPresenterCommands.CellLeft);
            //}
        }

        void xgrid1_Grouped(object sender, Infragistics.Windows.DataPresenter.Events.GroupedEventArgs e)
        {


            if (xgrid1.FieldLayouts[0].SortedFields.Count < sortcount)
            {
                

            //    xgrid1.FieldLayouts[0].SortedFields.Clear();
                //// throw new NotImplementedException();
                FieldSortDescription[] sortfieldsnew  = new FieldSortDescription[5];
                for (int i = 0; i < sortcount; i++)
                {
                  //  sortfields[i].IsGroupBy = false;
                    if (xgrid1.FieldLayouts[0].SortedFields.Contains(sortfields[i]))
                    {
                        FieldSortDescription fsd = new FieldSortDescription();
                        fsd.Direction = sortfields[i].Direction;
                        fsd.Field = sortfields[i].Field;
                        fsd.FieldName = sortfields[i].FieldName;

                        fsd.IsGroupBy = sortfields[i].IsGroupBy;

                        xgrid1.FieldLayouts[0].SortedFields.Add(fsd);
                    }
                    else
                    {
                        FieldSortDescription fsd1 = new FieldSortDescription();
                        fsd1.Direction = sortfields[i].Direction;
                        fsd1.Field = sortfields[i].Field;
                        fsd1.FieldName = sortfields[i].FieldName;

                        fsd1.IsGroupBy = false;

                        xgrid1.FieldLayouts[0].SortedFields.Add(fsd1);
                    }

                }
            }
            
        }

        void xgrid1_Grouping(object sender, Infragistics.Windows.DataPresenter.Events.GroupingEventArgs e)
        {
           
           // throw new NotImplementedException();
            xgrid1.FieldLayouts[0].SortedFields.CopyTo(sortfields, 0);
            sortcount = xgrid1.FieldLayouts[0].SortedFields.Count; 
            
        }

        private void clearfitlers_Click(object sender, RoutedEventArgs e)
        {
            xgrid1.FieldLayouts[0].RecordFilters.Clear(); 
        }

        private void savecustom_Click(object sender, RoutedEventArgs e)
        {
          //  xgrid1.
              save = xgrid1.SaveCustomizations();

            StreamWriter sw = new StreamWriter("Save.xml");
            sw.Write(save);
            sw.Close();
            MessageBox.Show(save);
        }

        private void LoadCustom_Click(object sender, RoutedEventArgs e)
        {
            //StreamReader sr = new StreamReader("new.xml");
            //save = sr.ReadToEnd();
            //load = true;
            xgrid1.LoadCustomizations(save);

          //  xgri .LoadCustomizations(save);
        }

        private void adddata_Click(object sender, RoutedEventArgs e)
        {
            Person p11 = new Person() { Name = "trish", Age = 23, Occupation = "teacher", Salary = 500.00 };
            people.Add(p11);
        }
    }
}
